﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using EasyBuildSQL;
using System.IO;

namespace webSample1
{
    public partial class frmExecuteBatchSQL : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                //Create ebQuery to Country
                ebQuery qCountry = new ebQuery(Global.Credentials);
                //Add SQL Sentence
                qCountry.AddSQL("SELECT * FROM country");

                //Create dataset
                var qCountryDS = qCountry.OpenDataSet();

                //Assign the DataSource to the control and fill the DropDownList
                cboCountry.DataSource = qCountryDS.Tables[0];
                cboCountry.DataTextField = "country_name";
                cboCountry.DataValueField = "countryID";
                cboCountry.DataBind();
                // cboCountry.SelectedValue = "1";


                //Create ebQuery to CivilState
                ebQuery qCivilState = new ebQuery(Global.Credentials);
                //Add SQL Sentence
                qCivilState.AddSQL("SELECT * FROM civil_state");

                //Create dataset
                var qCivilStateDS = qCivilState.OpenDataSet();

                cboCivilState.DataSource = qCivilStateDS.Tables[0];
                cboCivilState.DataTextField = "state_descrip";
                cboCivilState.DataValueField = "civilstateID";
                cboCivilState.DataBind();
                cboCivilState.SelectedValue = "1";

                //Create ebQuery to AddressType
                ebQuery qAddressType = new ebQuery(Global.Credentials);
                //Add SQL Sentence
                qAddressType.AddSQL("SELECT * FROM address_type");

                //Create dataset
                var qAddressTypeDS = qAddressType.OpenDataSet();

                cboAddressType.DataSource = qAddressTypeDS.Tables[0];
                cboAddressType.DataTextField = "type_descrip";
                cboAddressType.DataValueField = "addresstypeID";
                cboAddressType.DataBind();
                cboAddressType.SelectedValue = "1";

            }

        }

        protected void ExecBatch_Click(object sender, EventArgs e)
        {
            ebBATCH Batch = new ebBATCH(Global.Credentials);

            //1rst -  Insert into person table
            DataINSERT iPerson = Batch.Insert("person");
            iPerson.AddField("firstname", System.Data.DbType.String, txtFirstName.Text);
            iPerson.AddField("lastname", System.Data.DbType.String, txtLastName.Text);

            if (FileUpload1.FileName == string.Empty)
            {
                iPerson.AddNULL("photo");
            }
            else
            {
                //Define the photo file name
                string PhotoUpload = Path.Combine(base.MapPath("."), "photoUpload.jpg");

                //If file exists then delete
                if (File.Exists(PhotoUpload))
                    File.Delete(PhotoUpload);

                FileUpload1.SaveAs(PhotoUpload);
                //Add Field with BLOB Parameter
                iPerson.AddBLOB("photo", PhotoUpload);
            }
            //Add Civil state field
            iPerson.AddField("civilstateID", System.Data.DbType.Int16, int.Parse(cboCivilState.SelectedValue));


            //finish the insert
            iPerson.Finish();
            

            //Notice must save the identity
            Batch.ReturnIDENTITY = true;

            //notice to ebBatch to take the identity value, in this case save the last identoty in a 
            //local batch variable
            Batch.GetIdentity();

            //2nd - insert in address Table
            DataINSERT iAddress = Batch.Insert("physical_address");

            //Add Field street
            iAddress.AddField("street", System.Data.DbType.String, txtStreet.Text);
            //Add Field city whith second alternative
            iAddress.AddField("city", System.Data.DbType.String, txtCity.Text);
            //Add Field CountryID
            iAddress.AddValue("countryID", int.Parse(cboCountry.SelectedValue));
            //Add phone 
            if (txtPhone.Text == string.Empty)
                iAddress.AddNULL("phone");
            else
                iAddress.AddField("phone", System.Data.DbType.String, txtPhone.Text);
            //Add field fax
            if (txtFax.Text == string.Empty)
                iAddress.AddNULL("fax");
            else
                iAddress.AddField("fax", System.Data.DbType.String, txtFax.Text);

            //finish the insert
            iAddress.Finish();

            //3rd - Insert into the relation table address_person
            DataINSERT iAddressPerson = Batch.Insert("address_person");
            //Insert the personID wjth the Identity value saved 
            iAddressPerson.UseIdentityEnabled = true;
            iAddressPerson.AddIdentity("personID");

            //Insert the AddressID with the last identity value
            iAddressPerson.UseIdentityEnabled = false;
            iAddressPerson.AddIdentity("addressID");

            //Insert the value address type
            iAddressPerson.AddField("addresstypeID", System.Data.DbType.Int16, int.Parse(cboAddressType.SelectedValue));

            //The identity isn't necesary
            iPerson.ReturnIDENTITY = false;

            //Close the insert
            iAddressPerson.Finish();

            //Notice must save the identity
            Batch.ReturnIDENTITY = false;

  
            if (Batch.Execute())
            {
                txtResult.Text = "batch run fine!!!";
            }
            else
            {
                txtResult.Text = "Error SQL = " + Batch.ErrorSQL;
            }
        }

    }
}
