﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using EasyBuildSQL;

namespace webSample1
{
    public partial class frmOpenQuery : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {

                //Create ebQuery to Country
                ebQuery qCountry = new ebQuery(Global.Credentials);
                //Add SQL Sentence
                qCountry.AddSQL("SELECT * FROM country");

                //Create dataset
                var qCountryDS = qCountry.OpenDataSet();

                cboCountry.DataSource = qCountryDS.Tables[0];
                cboCountry.DataTextField = "country_name";
                cboCountry.DataValueField = "countryID";
                cboCountry.DataBind();
                cboCountry.SelectedValue = "1";

                //Create ebQuery to AddressType
                ebQuery qAddressType = new ebQuery(Global.Credentials);
                //Add SQL Sentence
                qAddressType.AddSQL("SELECT * FROM address_type");

                //Create dataset
                var qAddressTypeDS = qAddressType.OpenDataSet();

                cboAddressType.DataSource = qAddressTypeDS.Tables[0];
                cboAddressType.DataTextField = "type_descrip";
                cboAddressType.DataValueField = "addresstypeID";
                cboAddressType.DataBind();
                cboAddressType.SelectedValue = "1";
            }
        }

        protected void btnOpenSP_Click(object sender, EventArgs e)
        {
            ebQuery Query = new ebQuery(Global.Credentials);

            Query.AddSQL("SELECT p.personID, p.firstname, p.lastname, p.email, ");
            Query.AddSQL("pa.street,pa.city, c.country_name, pa.phone, at.type_descrip, cs.state_descrip ");
            Query.AddSQL("FROM person p ");
            Query.AddSQL("INNER JOIN address_person ap ON p.personID = ap.personID ");
            Query.AddSQL("INNER JOIN physical_address pa ON ap.addressID = pa.addressID ");
            Query.AddSQL("INNER JOIN address_type at ON ap.addresstypeID = at.addresstypeID ");
            Query.AddSQL("INNER JOIN civil_state cs ON p.civilstateID = cs.civilstateID ");
            Query.AddSQL("INNER JOIN country c ON pa.countryID = c.countryID ");
            //Add condition with parameter
            Query.AddSQL("WHERE pa.countryID = ?COUNTRYID ");
            Query.AddSQL("AND ap.addresstypeID = ?ADDRESTYPE ");

            //Add parameters
            Query.AddParameter("COUNTRYID", System.Data.DbType.Int32, cboCountry.SelectedValue);
            Query.AddParameter("ADDRESTYPE", System.Data.DbType.Int16, cboAddressType.SelectedValue);

            var dsQuery = Query.OpenDataSet();

            if (dsQuery == null)
            {
                txtResult.Text = Query.ErrorSQL;
                GridView1.DataSource = null;
                GridView1.DataBind();
            }
            else
            {
                txtResult.Text = "Open Query OK";

                GridView1.DataSource = dsQuery.Tables[0];
                GridView1.DataBind();
            }

        }
    }
}
